jQuery(function($) {
	$('label.data_use_check').on('change', 'input[type=checkbox]', function() {
		$label = $(this).parents('label');

		if($(this).attr('checked')) {
			$label.next().show();
		} else {
			$label.next().hide();
			var $target = $label.next();
			$target.find('input[type=text], input[type=hidden]').val('');
			$target.find('input[type=checkbox]:checked').removeAttr('checked');
		}
	});

	$('label.data_custom_check').on('change', 'input[type=checkbox]', function() {
		$label = $(this).parents('label');

		if($(this).attr('checked')) {
			if(!$label.parent().find('input.document_srl').val()) {
				alert('문서를 수동으로 지정하지 않고는 내용 일부 교체는 불가능합니다.');
				$(this).removeAttr('checked');
				return;
			}
			$label.next().show();
		} else {
			$label.next().hide();
			var $target = $label.next();
			$target.find('input[type=text], input[type=hidden]').val('');
			$target.find('input[type=checkbox]:checked').removeAttr('checked');
		}
	});
});
function magicContent() {};
magicContent.prototype.processSetup = function(is_complete) {
	$form = jQuery('#setupForm');
	var data = $form.serialize();
	data += '&is_complete=' + is_complete;
	jQuery.ajax({
		type: "POST",
		contentType: "application/json; charset=utf-8",
		dataType: "json",
		url: './index.php',
		error: function (jqXHR, textStatus, errorThrown) {
			alert ('[' + textStatus+ ']' +errorThrown + ' : ' + jqXHR.responseText);
		},
		data: data,
		success: function (json) {
			if(is_complete == 0) window.location.reload();
			else {
				opener.window.location.reload();
				setTimeout(function() { window.close(); }, 100);
			}
		}
	});
};

magicContent.prototype.insertDocument = function(target) {
	var $target = jQuery(target);
	var $form = $target.parents('form');
	$form.find('input.document_srl').removeClass('target');
	$target.parent().find('.document_srl').addClass('target');

	var url = window.request_uri.setQuery('act', 'dispMagiccontentInsertDocument').setQuery('widget_sequence', $form.find('input[name=widget_sequence]').val());
	popopen(url, 'select_document');
}

magicContent.prototype.searchDocument = function(target) {
	var $target = jQuery(target);
	var $form = $target.parents('form');
	$form.find('input.document_srl').removeClass('target');
	$target.parent().find('.document_srl').addClass('target');

	var url = $form.attr('data-search-document-url') + '&widget_sequence=' + $form.find('input[name=widget_sequence]').val();
	popopen(url, 'select_document');
}

magicContent.prototype.resetDocument = function(target) {
	var $target = jQuery(target);
	var $form = $target.parents('form');
	$target.parent().find('.document_srl').val('');

	this.processSetup(0);
}

magicContent.prototype.selectDocument = function(target) {
	var $tr = jQuery(target).parents('tr');
	var document_srl = $tr.attr('data-document-srl');
	var title = $tr.attr('data-document-title');

	var $opener = jQuery(opener.document);
	$opener.find('form#setupForm').find('input.document_srl.target').val(document_srl).prev().val(title);
	opener.magiccontent.processSetup(0);
	window.close();
}

var magiccontent = new magicContent();

function completeDocumentInserted(ret) {
	var $opener = jQuery(opener.document);

	$opener.find('form#setupForm').find('input.document_srl.target').val(ret.document_srl).prev().val(ret.title);
	opener.magiccontent.processSetup(0);
	window.close();
}